import * as React from 'react';
import { Button, Table, Header, Container } from 'semantic-ui-react';
import { DetailContainer } from '@overflow/commons/react/component/DetailContainer';
import { TargetDetailInfra } from './TargetDetailInfra';
import Target from '@overflow/target/api/model/Target';


export interface StateProps {
}

export interface DispatchProps {
}

export type Props = StateProps & DispatchProps;

export interface State {
  target: any; // todo. fix to Target
}


export class TargetDetail extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);
    this.state = {
      target: null,
    };
  }

  public componentWillMount(): void {
    let data = {
      'id': '1',
      'createDate': '2017-01-01',
      'displayName': '192.168.1.105',
      'description': '',
      'sensorCount': 'todo.',
    };

    this.setState({ target: data });
  }

  public handleRemoveTarget(): void {
    alert('remove');
  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        <TargetBasicInfo target={this.state.target} />
        <br />
        <TargetDetailInfra target={this.state.target} />
        <br />
        <Button primary floated={'right'} negative onClick={this.handleRemoveTarget}>Remove</Button>
      </Container>
    );
  }
}


export interface TargetBasicInfoProps {
  target?: any; // todo. fix to Target
}

export interface TargetBasicInfoState {
  infra: any;
}

export class TargetBasicInfo extends React.Component<TargetBasicInfoProps, TargetBasicInfoState> {

  constructor(props: TargetBasicInfoProps, context: TargetBasicInfoState) {
    super(props, context);
    this.state = {
      infra: null,
    };
  }

  public componentWillMount(): void {
    let infra = {
      'id': '1',
      'createDate': '2017-01-01',
      'childId': '111',
      'type': 'Host',
    };
    this.setState({
      infra: infra,
    });
  }

  public render(): JSX.Element {
    return (
      <Container fluid>
        <Table celled={false}>
          <Table.Body>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Name</Header>
              </Table.Cell>
              <Table.Cell>
                {this.props.target.displayName}
              </Table.Cell>
            </Table.Row>

            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Description</Header>
              </Table.Cell>
              <Table.Cell>
                {this.props.target.description}
              </Table.Cell>
            </Table.Row>

            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Sensor Count</Header>
              </Table.Cell>
              <Table.Cell>
                {this.props.target.sensorCount}
              </Table.Cell>
            </Table.Row>

            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Created at</Header>
              </Table.Cell>
              <Table.Cell>
                {this.props.target.createDate}
              </Table.Cell>
            </Table.Row>

            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>Type</Header>
              </Table.Cell>
              <Table.Cell>
                {this.state.infra.type}
              </Table.Cell>
            </Table.Row>
          </Table.Body>
        </Table>
      </Container>
    );
  }
}
